#!/usr/bin/perl
#
#########################################################################
####                                                                #####
####                     SET-UP CONFIG STATS                        #####
####                                                                #####
####                       (http server)                            #####
####                                                                #####
####    domisse@w3perl.com                   version 01/02/2004     #####
####                                                                #####
#########################################################################
#

$version = "2.94"; 
$verdate = "01/02/04";

require "getopt.pl";
 
&Getopt('cdgijlopqrst');       

# PERL Path (Unix only) :
# edit to reflect the location of Perl on your host
# usually /usr/local/bin/perl or /usr/bin/perl
# change if need the first line of this script 


#
# $pathcgi is the path where the perl scripts will be
# installed. It should be somewhere inside your cgi-bin directory.
# It's a good idea to place the scripts inside a /w3perl/ subdirectory.
# Usual NT path is C:/Inetpub/wwwroot/cgi-bin/w3perl
# Your cgi path should at least have the word 'cgi' to be extracted later
# (/cgi-local/ or /richardsoncgi/ is ok, /binary-script/ not)
# (if you don't have cgi-bin, $pathcgi should be the same as $pathw3perl)

$pathcgi = "/var/w3perl/cgi-bin/w3perl";

#
# $pathw3perl is the path where the package have been installed
# it should be somewhere inside your webserver root.
# Usual NT path is C:/Inetpub/wwwroot/w3perl
#

$pathw3perl = "/home/domisse/public_html/w3perl";

#
# Install w3perl on virtual hosts (manually)
# You should specify the server name, logfile path and virtual web root
#

$virtual_web = "/usr/local/etc/first/htdocs";
$virtual_web_log = "/usr/local/etc/first/logs";
$virtual_www = "www.first.com";

#############
# Perl path #
#############

unless (defined $perlpath) {
        open(ME,$0) || die "Can't open $0\n";
        $perlpath = <ME>;
        $perlpath =~ s/^#\!\s*(.*)\/perl(.*)\n$/$1/;
        close(ME);
}

###########
# version #
###########

if ($opt_g eq '') {
require "pwd.pl";
&initpwd;
$version_config = $ENV{'PWD'}."/VERSION";
$upgrade_config = $ENV{'PWD'}."/upgrade.txt";

if (-f $version_config) {
    open(FILE,"$version_config");
    $version = <FILE>;
    close(FILE);
    chop($version);
}
}

# si upgrade.txt present, on l'utilise

if ($0 =~ /upgrade/) {
#if (-f $upgrade_config) {
    open(FILE,"$upgrade_config");
    $a = <FILE>;
    ($tmp,$up_perlpath) = split(/\s+/,$a); 
    $a = <FILE>;
    ($tmp,$up_pathw3perl) = split(/\s+/,$a); 
    $a = <FILE>;
    ($tmp,$up_pathcgi) = split(/\s+/,$a); 
    close(FILE);
    $pathw3perl = $up_pathw3perl;
    $perlpath = $up_perlpath;
    $pathcgi = $up_pathcgi;
}

#if (!(-f $upgrade_config) || ($up_perlpath ne $perlpath) || ($up_pathw3perl ne $pathw3perl) || ($up_pathcgi ne $pathcgi)) {
#if (!(-f $upgrade_config)) {
#    print "Writing upgrade\n";
    open(FILE,">$upgrade_config");
    print FILE "Perl $perlpath\n";
    print FILE "W3Perl $pathw3perl\n";
    print FILE "CGI $pathcgi\n";
    close(FILE);
#}

########
# init #
########

$azouz = 0;
$fly = "fly.exe";
$delete_files = 0;
$dirconfig = "config";
$dirresources = "resources";
$diradmin = "admin";
$locconf = "locconf";
$configmdk = "config-mdk";  # Generic mandrake configuration file
$locconf_default = "locconf.default";
$verbose = 1;
$plext = ".pl";  # Perl extension
$dirsep = "/";   # string separator
$mode = 0755;
$pagegraph = "pagegraph".$plext;
$pathflyrpm = "/usr/local/bin/";

# Apache configuration file

$scriptalias = "ScriptAlias";
#$perlpathtest = `/usr/bin/which perl`;
@apacheconf = ('httpd.conf','srm.conf','apache.conf');
@location = ('/usr/local/etc/httpd/conf/','/etc/conf/','/home/httpd/conf/','/usr/local/etc/apache/','/var/lib/apache/conf/','/usr/home/web4/usr/local/etc/httpd/conf/');

$fileconf = $location[0].$apacheconf[0]; # default;

# Directory w3perl output for virtual hosts
$stat_dir_output = "w3stats";

if ($virtual_www !~ /\d$/) {
    $localdomainename = substr($virtual_www,(index($virtual_www,'.')+1));
    $name_virtual_web = $localdomainename;
} else {
    $localdomainename = substr($virtual_www,0,(rindex($virtual_www,'.')+1));
    $name_virtual_web = $localdomainename;
    print "Warning : Can't compute domain name from a IP address, suggest $localdomainename\n";
}

#################################################################
###            parsing the command line option                ###
#################################################################

if ($opt_h == 1) {
      print STDOUT "Usage : \n";
      print STDOUT "        -a                             : autoinstall (main server)\n";
      print STDOUT "        -b                             : autoinstall (virtual host)\n";
      print STDOUT "        -d <w3perl cgi path>           : w3perl cgi directory\n";
      print STDOUT "        -i <w3perl path>               : w3perl directory\n";
      print STDOUT "        -j <apache config file>        : load apache configuration file\n";
      print STDOUT "        -u                             : autoinstall for virtual hosts\n";
      print STDOUT "        (use current cgi directory to detect virtual host)\n";
      print STDOUT "        -e                             : autoinstall for all virtual hosts\n";
      print STDOUT "        -g <file>                      : use ghost installer config\n";
      print STDOUT "        -o <stats_dir>                 : stat output directory (virtual host)\n";
      print STDOUT "        -r                             : install resource files (rpm)\n";
      print STDOUT "        -x                             : show default value for flag options\n";
      print STDOUT "        -v                             : version\n";
      print STDOUT "\n";
      exit;
}

if ($opt_v == 1) {
      print STDOUT "install.pl - version $version - $verdate\n";
      exit;
}

if ($opt_r ne '') {
# RPM Default
$delete_files = 1;
#$build_rpm = $opt_r;
#$build_rpm_tmp = "/var/tmp/w3perl-buildroot";
#$opt_i = "/home/httpd/htdocs/w3perl";
#$opt_d = "/home/httpd/cgi-bin/w3perl";
}


if ($opt_d ne '') {
$pathcgi = $opt_d;
}

if ($opt_i ne '') {
$pathw3perl = $opt_i;
}

if ($opt_j ne '') {
$fileconf = $opt_j;
}

if ($opt_o ne '') {
$dir_stat_output = $opt_o;
}

if ($opt_x == 1) {
      print STDOUT "Default : \n";
      print STDOUT "          -a               : ";
      &id($opt_a);
      print STDOUT "          -b               : ";
      &id($opt_b);
      print STDOUT "          -d               : $pathcgi\n";
      print STDOUT "          -i               : $pathw3perl\n";
      print STDOUT "          -j               : $fileconf\n";
      print STDOUT "          -u               : ";
      &id($opt_u);
      print STDOUT "          -e               : ";
      &id($opt_e);
      print STDOUT "          -g               : ";
      &id($opt_g);
      print STDOUT "          -o               : $stat_dir_output\n";
      print STDOUT "          -r               : $opt_r";
      print STDOUT "          -v               : $version\n";
      exit;
}

########################################
#         Flags option                 #
########################################

# To check : opt_u ==> master installation should be done first

if ($opt_b ne '') {
    push(@web,$virtual_web);
    push(@www,$virtual_www);
    push(@web_log,$virtual_web_log);
}

if ($opt_g ne '') {

    $file = $opt_g;
    &error_open($file) if (!(-r $file));
    open(FILE,"$file");
    while (<FILE>) {
	chop;
	($tmp1,$tmp2) = split(/=/,$_);
	$pathw3perl = $tmp2 if (/InstallPath/);
	$pathw3perl =~ s/\\/\//g;
	$pathcgi = $tmp2 if (/CGIPath/);
	$pathcgi =~ s/\\/\//g;
	$pathcgi_server = $tmp2 if (/CGIServer/);
	$pathcgi_server =~ s/\\/\//g;
    }
    close FILE;

#    ($pathw3perl,$pathcgi) = split(/,/,$opt_g);
#    $pathcgi = $pathcgi."cgi-bin/w3perl";
}

##########################
#     NT or Unix ?       #
##########################

$nt = 0;

# On teste le deuxieme caractere (':' sous NT)

$car = substr($pathw3perl,1,1);
$nt = 1 if ($car eq ':');

$user_home_pwd = (getpwuid($<))[7] if ($nt == 0); # Non supporte sous NT !

#################################################
# Unix : looking for apache configuration files #
#################################################

# -a : autoinstall 
# -u : autoinstall (virtual hosts)
# -e : autoinstall on all virtual hosts

if ($opt_a ne '' || $opt_u ne '' || $opt_e) {

# Try to guess from ENV (work only on Unix)

if ($opt_u ne '') {
    require "pwd.pl";
    &initpwd;

    # Test si le script est dans le repertoire cgi ou principal
    if ($ENV{'PWD'} =~ /cgi/) {
	$virtual_cgi = $ENV{'PWD'};
	$virtual_cgi =~ s/www/usr\/local\/etc\/httpd/ if ($azouz == 1);
	$virtual_cgi =~ s/$user_home_pwd// if ($azouz == 1);
    } else {
	$virtual_web_dir = $ENV{'PWD'};
	$virtual_web_dir =~ s/www/usr\/local\/etc\/httpd/ if ($azouz == 1);
	$virtual_web_dir =~ s/$user_home_pwd// if ($azouz == 1);
    }
}

# Try to find cgi-bin path from Apache configuration server

if ($opt_j eq '') {

print "<P><BR><B><LI>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Trying to find apache configuration file on Unix ...\n";
print "</B><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# Looking for Apache configuration file

$fileconf = $location[0].$apacheconf[0];

BOUCLE:
for ($j=0;$j<=$#apacheconf;$j++) {
    for ($i=0;$i<=$#location;$i++) {
	$fileconf = $location[$i].$apacheconf[$j];
#	print "$j $i $fileconf\n";
	last BOUCLE if (-f $fileconf);
    }
}

}

# Plusieurs fichiers de conf peuvent etre trouve ==> menu ?

if (-f $fileconf) {
print "Apache configuration file found : ";
print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "$fileconf";
print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# opt_a (Apache)
# install on main server

if ($opt_a ne '') {

    $out = 0;

# ScriptAlias doit etre en tout debut de ligne
# Exclus les scriptalias des virtualhost

    open(FILE,"$fileconf") || die "Can't open $fileconf\n";
    while (<FILE>) {
	chop;
	$out = 1 if /^\<VirtualHost/i;
	$out = 0 if (/^\<\/VirtualHost/i && $out == 1);
	($scriptalias,$repcgi,$pathcgi) = split(/\s+/) if (/^ScriptAlias/i && $out == 0);
	($scriptalias,$pathw3perl) = split(/\s+/) if (/^DocumentRoot/i && $out == 0);
#	$pathw3perl = $pathw3perl.$dirsep.$stat_dir_output;

	$pathw3perl = $ENV{'PWD'};
	$pathw3perl =~ s/www/usr\/local\/etc\/httpd/ if ($azouz == 1);
	$pathw3perl =~ s/$user_home_pwd// if ($azouz == 1);
    }
    close(FILE);

    $pathcgi =~ s/\"//g;
    $pathw3perl =~ s/\"//g;
    print "CGI Path : ";
    print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "$pathcgi";
    print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "W3Perl Path : ";
    print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "$pathw3perl";
    print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    
    if ($pathcgi !~ /cgi-bin/) {
	print "Problem cgi-bin : $pathcgi\n";
	exit;
    }
}

# opt_u (Apache)
# install for virtual hosts (detect from pwd)

if ($opt_u ne '' || $opt_e ne '') {
    $virtual_www = '';
    $found = 0;
    $out = 1;
    open(FILE,"$fileconf") || die "Can't open $fileconf\n";
    while (<FILE>) {
	chop;

	# ServerName ==> $virtual_www

	$out = 0 if (/^\<VirtualHost/i && $found != 1);
	$out = 1 if (/^\<\/VirtualHost/i && (($out == 0) || $found == 1));

	if ($out == 0) {
	    s/\>//;

	    ($scriptalias,$virtual_www) = split(/\s*ServerName\s*/) if (/ServerName/i);

	    if ($virtual_www eq '') {
		($scriptalias,@tmp) = split(/\s+/) if (/^\<VirtualHost/i);

#	    print "Error, unable to find virtual host name\n" if ($#tmp == -1);

		if ($#tmp == 0) {
		    $virtual_www = $tmp[0];
		    $pos = rindex($virtual_www,'.',length($virtual_www));
		    $racine = substr($virtual_www,0,$pos);
		    print "Error, invalid virtual host name : $virtual_www\n" if (index($racine,'.') == -1);
		} else {
		
		    if ($#tmp > 0) {
			foreach $tmp1 (@tmp) {
			    $pos = rindex($tmp1,'.',length($tmp1));
			    $racine = substr($tmp1,0,$pos);
			    $virtual_www = $tmp1 if (index($racine,'.') != -1);
			}
		    }
		}
	    }

	    if ($opt_e == 1 && !($seen{$virtual_www}++) && $virtual_www ne '') {
		push(@www,$virtual_www);
#		print "A - $virtual_www\n";
	    }

	    # TransferLog ==> $virtual_web_log
	    ($scriptalias,$tmp) = split(/\s*TransferLog\s*/) if (/TransferLog/i);
	    ($scriptalias,$tmp) = split(/\s*CustomLog\s*/) if (/CustomLog/i);
	    $pos = rindex($tmp,'/',length($tmp));
	    $virtual_web_log = substr($tmp,0,$pos);
	    $virtual_web_log =~ s/www/usr\/local\/etc\/httpd/ if ($azouz == 1);

	    if ($opt_e == 1 && !($seen{$tmp}++) && $tmp ne '') {
		push(@web_log,$virtual_web_log);
#		print "B $virtual_web_log - $tmp\n";
	    }

	    # DocumentRoot ==> $virtual_web
	    ($scriptalias,$virtual_web) = split(/\s*DocumentRoot\s*/) if (/DocumentRoot/i);
	    $virtual_web =~ s/www/usr\/local\/etc\/httpd/ if ($azouz == 1);

	    # ScriptAlias ==> $virtual_cgi
	    if (/ScriptAlias/i) {
		($scriptalias,$cgi_bin,$virtual_cgi_tmp) = split(/\s*ScriptAlias\s*/);
		($cgi_bin,$virtual_cgi_tmp) = split(/\s+/,$cgi_bin);
		$virtual_cgi_tmp =~ s/www/usr\/local\/etc\/httpd/ if ($azouz == 1);
		chop($virtual_cgi_tmp);
	    }


	    if ($opt_e == 1 && !($seen{$virtual_cgi_tmp}++) && $virtual_cgi_tmp ne '') {
		push(@web_cgi,$virtual_cgi_tmp);
	    }

	    if ($opt_e == 1 && !($seen{$virtual_web}++) && $virtual_web ne '') {
		push(@web,$virtual_web);
#		print "C $virtual_web\n";
	    }

	    if ($opt_e eq '') {

	    $found = 1 if ($virtual_cgi_tmp eq $virtual_cgi && ($ENV{'PWD'} =~ /cgi/)); # script d'install dans le repertoire cgi du serveur virtuel
	    $found = 1 if ($virtual_web_dir eq $virtual_web && ($ENV{'PWD'} !~ /cgi/)); # script d'install dans le repertoire principal
	}
	}
    }
    close(FILE);

    if ($opt_u ne '') {
	if ($found != 1) {
	    print "No path matching in the server configuration file !\n";
	    exit;
	}
	push(@www,$virtual_www);
	push(@web_log,$virtual_web_log);
	push(@web,$virtual_web);
	push(@web_cgi,$virtual_cgi_tmp);
    }

    if ($virtual_www eq '') {
	print "Error, unable to find virtual host name\n";
	exit;
    }
    if ($virtual_web eq '') {
	print "Error, unable to find virtual host path\n";
	exit;
    }
    if ($virtual_web_log eq '') {
	print "Error, unable to find virtual host logfile path\n";
	exit;
    }

    if ($opt_e eq '') {
	print "Virtual Host Name : ";
	print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "$virtual_www";
	print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "Virtual Host Path : ";
	print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "$virtual_web";
	print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "Virtual Host Log Path : ";
	print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "$virtual_web_log";
	print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    }
}

} else {
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Failed to find any apache configuration file\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Use the '-j' flag to load it manually\n\n";
print "<P><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
$abort = 1;
}

# End auto-install
}


#########################################################################
#               Auto install for users on virtual host                  #
#########################################################################

if ($opt_u ne '' || $opt_e ne '' || $opt_b ne '') {

# Step 1 : get pwd from current directory
# Step 2 : Read httpd.conf to get $virtual_web (virtual web root path)
#                                 $virtual_web_log (virtual web logfile path)
#                                 $virtual_www (virtual web name)
# Step 1 : Create symbolic links
# Step 2 : Copy generic config.pl file to config-<web>.pl
# Step 3 : Alter config-<web>.pl
# step 4 : Copy config-<web>.pl and cron-w3perl.pl to client cgi-bin
# Step 5 : Create /resources/admin/config-<web> and /config/config-<web>.pl
# Step 6 : Modify /resources/admin/locconf

# On doit aussi recopier pagegraph.pl dans le repertoire cgi du serveur
# virtual si celui-ci existe.

    for ($i=0;$i<=$#www;$i++) {
	print "Server : $www[$i]\n";
	
	if ($azouz == 1) {
	    $web[$i] = $user_home_pwd.$web[$i];
	    $web_log[$i] = $user_home_pwd.$web_log[$i];
	    $web_cgi[$i] = $user_home_pwd.$web_cgi[$i];
	}
	
#	    $localdomainename = substr($www[$i],(index($www[$i],'.')+1));
#	    $name_virtual_web = $localdomainename;
	
	if ($virtual_www !~ /\d$/) {
	    $localdomainename = substr($www[$i],(index($www[$i],'.')+1));
	    $name_virtual_web = $localdomainename;
	} else {
	    $localdomainename = substr($www[$i],0,(rindex($www[$i],'.')+1));
	    $name_virtual_web = $localdomainename;
	}
	
	print "Warning : Can't compute domain name from a IP address, suggest $localdomainename\n" if ($www[$i] =~ /\d$/);
	
	print "Create symbolic links\n";
	
        # Create stats output dir

	$tmp = $web[$i].$dirsep.$stat_dir_output;
	mkdir ($tmp,0775) unless -d $tmp;

        # Dir docs

	$newfile = $web[$i].$dirsep.$stat_dir_output.$dirsep."docs";
	$oldfile = $pathw3perl.$dirsep."docs";

	symlink($oldfile,$newfile);
	
        # Dir resources

	$newfile = $web[$i].$dirsep.$stat_dir_output.$dirsep."resources";
	$oldfile = $pathw3perl.$dirsep."resources";
	
	symlink($oldfile,$newfile);

        # Dir admin

	$newfile = $web[$i].$dirsep.$stat_dir_output.$dirsep."admin";
	$oldfile = $pathw3perl.$dirsep."admin";
	
	symlink($oldfile,$newfile);

        # Copy pagegraph.pl dans le cgi du serveur virtual si il existe

	if ($virtual_cgi ne '') {
	    print "Copy cgi w3perl scripts\n";

	    # make subdirectory w3perl inside cgi virtual server

	    $tmp2 = $virtual_cgi.$dirsep."w3perl";
	    mkdir ($tmp2,0775) unless -d $tmp2;

	    $file_update = $pathcgi.$dirsep.$pagegraph;

	    &error_open($file_update) if (!(-r $file_update));
	    open(FILE,"$file_update");
	    @lines = (<FILE>);
	    close FILE;

	    $file_update2 = $virtual_cgi.$dirsep."w3perl".$dirsep.$pagegraph;
	
	    &error_write($file_update2) if (!(-w $virtual_cgi));
	    open(FILE,">$file_update2") || die "Can't open $file_update2";

	    foreach $line (@lines) {
		print FILE "$line";
	    }

	    close(FILE);
	    &set_perm($file_update2,$mode);
	}

        # Copy generic config file
        # Attention : par interface web, pble de droit d'ecriture dans /cgi-bin/w3perl/ !

	print "Building generic w3perl configuration file\n";

#	$pathcgi = $user_home_pwd.$pathcgi if ($azouz == 1);
	$file_update = $pathcgi.$dirsep."config".$plext;

	&error_open($file_update) if (!(-r $file_update));
	open(FILE,"$file_update");
	@lines = (<FILE>);
	close FILE;
	
        # on copie le fichier dans le repertoire principal cgi-bin config-<web>.pl
        ### on copie le fichier dans le repertoire virtualhost cgi-bin config.pl

	$file_configdomain = $pathcgi.$dirsep."config"."-".$name_virtual_web.$plext;
#	$file_update2 = $virtual_cgi.$dirsep."config".$plext;
	
	&error_write($file_configdomain) if (!(-w $pathcgi));
#	&error_write($file_update2) if (!(-w $virtual_cgi));

	open(FILE,">$file_configdomain") || die "Can't open $file_configdomain";
#	open(FILE2,">$file_update2") || die "Can't open $file_update2";

	foreach $line (@lines) {
	    $line =~ s/\$path = \"(.*)\"/\$path = \"$tmp$dirsep\"/;
	    $line =~ s/\$pathinit = \"(.*)\"/\$pathinit = \"$pathw3perl$dirsep\"/;
	    $line =~ s/\$pathserver = \"(.*)\"/\$pathserver = \"$web[$i]$dirsep\"/;
	    $line =~ s/\$fileroot = \"(.*)\"/\$fileroot = \"$web_log[$i]$dirsep\"/;
	    $line =~ s/\$cgipath = \"(.*)\"/\$cgipath = \"$web_cgi[$i]$dirsep\"/;
	    $line =~ s/\$localserver = \"(.*)\"/\$localserver = \"$www[$i]\"/;
	    $line =~ s/\$localdomaine = \"(.*)\"/\$localdomaine = \"$localdomainename\"/;
	    $line =~ s/\$localdomainename = \"(.*)\"/\$localdomainename = \"$localdomainename\"/;
	    $line =~ s/\$emailadr = \"(.*)\"/\$emailadr = \"webmaster\\\@$localdomainename\"/;
	    print FILE "$line";
#	    print FILE2 "$line";
	}

	close(FILE);
#	close(FILE2);

        # Copy cron-w3perl.pl dans le repertoire virtualhost cgi-bin

	print "Building generic cron-w3perl script\n";

	$file_update = $pathcgi.$dirsep."cron-w3perl".$plext;

	&error_open($file_update) if (!(-r $file_update));
	open(FILE,"$file_update");
	@lines = (<FILE>);
	close FILE;
	
        # on copie le fichier dans le repertoire virtualhost cgi-bin config.pl

	$file_update = $virtual_cgi_tmp if ($ENV{'PWD'} =~ /cgi/); # script d'install dans le repertoire cgi du serveur virtuel
	$file_update = $virtual_web if ($ENV{'PWD'} !~ /cgi/); # Script d'install dans le repertoire principal
	$file_update = $user_home_pwd.$file_update if ($azouz == 1);

	&error_write($file_update) if (!(-w $file_update));

	$file_update .= $dirsep."cron-w3perl".$plext; 

#	&error_write($file_update) if (!(-w $virtual_cgi));


	open(FILE,">$file_update") || die "Can't open $file_update";
	foreach $line (@lines) {
	    $out = 0;
	    $out = 1 if ($line =~ /^\# init/);
	    if ($out == 1) {
		$out = 0;
		print FILE "\$opt_c = 1;\n";
	    }
	    $line =~ s/\$configfile = (.*);$/\$configfile = \"$file_configdomain\";/;
	    
#	    $line =~ s/\$path = \"(.*)\"/\$path = \"$tmp$dirsep\"/;
#	    $line =~ s/\$pathinit = \"(.*)\"/\$pathinit = \"$pathw3perl$dirsep\"/;
#	    $line =~ s/\$pathserver = \"(.*)\"/\$pathserver = \"$web[$i]$dirsep\"/;
#	    $line =~ s/\$fileroot = \"(.*)\"/\$fileroot = \"$web_log[$i]$dirsep\"/;
#	    $line =~ s/\$localserver = \"(.*)\"/\$localserver = \"$www[$i]\"/;
#	    $line =~ s/\$localdomaine = \"(.*)\"/\$localdomaine = \"$localdomainename\"/;
#	    $line =~ s/\$localdomainename = \"(.*)\"/\$localdomainename = \"$localdomainename\"/;
#	    $line =~ s/\$emailadr = \"(.*)\"/\$emailadr = \"webmaster\\\@$localdomainename\"/;
	    print FILE "$line";
	}

	close(FILE);
	&set_perm($file_update,$mode);

    }

    print "Installation successful\n" if ($abort != 1);
    exit;
}

#

if ($ENV{'REQUEST_METHOD'} eq "GET") {
        print "Content-type: text/html\n\n";
        print "<HTML><HEAD><TITLE>Installation</TITLE></HEAD>\n";
        print "<BODY BGCOLOR=\"#FFFFFF\" TEXT=\"#000000\">\n";
}

#########
# Title #
#########

print "<P><BR><H3><CENTER>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Installing w3perl in progress...\n";
print "</H3><P></CENTER><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#################################################
# Reading parameters from the first three lines #
#################################################

if ($opt_g eq '' && $opt_r eq '') {
print "<BR><B><LI>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Reading path paramaters within this script\n";
print "</B><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# Figure out the path to "perl" by reading ourself.

unless (defined $perlpath) {
        open(ME,$0) || die "Can't open $0\n";
        $perlpath = <ME>;
        $perlpath =~ s/^#\!\s*(.*)\/perl(.*)\n$/$1/;
        close(ME);
}


if ($verbose) {
print "Perl path is : ";
print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "$perlpath\n";
print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "Cgi path is : ";
print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "$pathcgi\n";
print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "W3perl path is : ";
print "<I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "$pathw3perl\n";
print "</I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}
}

#if ($azouz == 1) {
#    $pathcgi = $user_home_pwd.$pathcgi;
#    $pathw3perl = $user_home_pwd.$pathw3perl;
#}

# Init

$path3 = $pathw3perl;
$initw3perl = $path3;
$path3 .= $dirsep;
$path2 = $pathcgi.$dirsep;

#################################################
#        Installing resource file (RPM)         #
#################################################

if ($opt_r ne '') {

print "<BR><B><LI>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "> Installing resource file\n";
print "</B><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
# Dest $pathw3perl

require "pwd.pl";
&initpwd;

$dir = $ENV{'PWD'};
$dir_base = $dir."/";
$filename = "/resources/rpmfile";

# Default RPM install
#$dir_cgi = $opt_r.$opt_d;
#$dir_html = $opt_r.$opt_i;
$dir_cgi = $opt_d;
$dir_html = $opt_i;
#$dir_cgi = "/home/httpd/cgi-bin/w3perl" if ($opt_d eq '');
#$dir_html = "/home/httpd/htdocs/w3perl" if ($opt_i eq '');

# directory a la racine

$tmp2 = 1;
$tmp = $dir_html;
#chop($tmp);
$tmp2 = mkdir ($tmp,0775) unless -d $tmp;

# en cas d'echec, on essaye un repertoire en dessous

$i = 0;
while ($tmp2 == 0 && $tmp ne '') {
    $i++;
    $tmpold[$i] = $tmp;
    $tmp = substr($tmp,0,rindex($tmp,$dirsep)+1);
    chop($tmp);
    $tmp2 = mkdir ($tmp,0775) unless -d $tmp;
}

if ($i != 0) {
    for ($j=$i;$j>$0;$j--) {
	$tmp = $tmpold[$j];
	$tmp2 = mkdir ($tmp,0775) unless -d $tmp;
    }
}

if ($tmp2 == 0) {
    print "Failed to create $dir_html";
    exit;
}

#

$tmp2 = 1;
$tmp = $dir_cgi;
#chop($tmp);
$tmp2 = mkdir ($tmp,0775) unless -d $tmp;

$i = 0;
while ($tmp2 == 0 && $tmp ne '') {
    $i++;
    $tmpold[$i] = $tmp;
    $tmp = substr($tmp,0,rindex($tmp,$dirsep)+1);
    chop($tmp);
    $tmp2 = mkdir ($tmp,0775) unless -d $tmp;
}

if ($i != 0) {
    for ($j=$i;$j>$0;$j--) {
	$tmp = $tmpold[$j];
	$tmp2 = mkdir ($tmp,0775) unless -d $tmp;
    }
}

if ($tmp2 == 0) {
    print "Failed to create $dir_cgi";
    exit;
}

#

open (FILE,">$dir$filename");
&dodir($dir);
close(FILE);

}

########################################
# Making subdirectory inside /cgi-bin/ #
########################################

if ($pathcgi ne $pathw3perl && ($ENV{'REQUEST_METHOD'} ne "GET")) {

$pos = rindex($pathcgi,$dirsep);
$cgisubdir = substr($pathcgi,0,$pos);
#($tmp) = (stat($cgisubdir)) [4];

#if ($tmp == 0 && $nt == 0) {
#    print "<BR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
#    print "\nYou should run this script as root\n";
#    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#    exit;
#}

if (!(-d $cgisubdir)) {
    $tmp = mkdir ($cgisubdir,0775);
    if ($tmp != 1) {
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "\nError, unable to create $cgisubdir - $!\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "Run the script as root or create the subdirectory by yourself\n";
	print "<BR><I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "(PS: The script may be confused with symbolic links)\n";
	print "</I><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	exit;
    }
}

if (!(-d $pathcgi)) {
    $tmp = mkdir ($pathcgi,0775);
    if ($tmp != 1) {
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "\nError, unable to create $pathcgi - $!\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "Run the script as root or create the subdirectory by yourself\n";
	print "<BR><I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	print "(PS: The script may be confused with symbolic links)\n";
	print "</I><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
	exit;
    }
}

print "> Making $pathcgi\n";
}

# RiscOS
 
if ($dirsep eq "." && !(-f "$path2$conf")) {;
$plext = "/pl";
$conf = "config".$plext;
}

$conf = "config".$plext;
$lib = "libw3perl".$plext;
$netgeo = "netgeo".$plext;
$geoip_free = "geoip_free".$plext;
$fixperlpath = "fixperlpath".$plext;
$oldlib = $lib;
$init = "init".$plext;
$confstat = "confstat".$plext;
$delconf = "delconf".$plext;
$schedule = "schedule".$plext;
$runconf = "runconf".$plext;
$cronw3perl = "cron-w3perl".$plext;

################################################
# Modify /cgi-bin/ links in /admin/index.html  #
################################################

######## Le code vient de init.pl pour calculer $cgiurl

$pos = rindex($pathcgi,"cgi");
$cgiurl = substr($pathcgi,$pos-1,length($pathcgi));
$bkg = substr($pathcgi,$pos-1,1);

if ($bkg ne $dirsep) {
$tmp = substr($pathcgi,0,$pos-1);
$pos2 = rindex($tmp,$dirsep);
$cgiurl = substr($pathcgi,$pos2,length($pathcgi));
}

### /cgi-bin/w3perl is default w3perl scripts installation

print  "> Updating admin page ... \n" if $verbose;
print "</B><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

$admin_page = $pathw3perl."/admin/index.html";

# On modifie la page /admin/index.html (/cgi-bin/w3perl --> $cgiurl)

&error_open($admin_page) if (!(-r $admin_page));
open(FILE,"$admin_page");
@lines = (<FILE>);
close FILE;

&error_write($admin_page) if (!(-w $admin_page));
open(FILE,">$admin_page") || die "Can't open $admin_page";
foreach $line (@lines) {
#    $line =~ s/HREF=\"(.*)\/(\w+)\.(\w+)\?(.*)/HREF=\"$cgiurl\/$2\.$3\?$4/;
    $line =~ s/HREF=\"\/(.*)\/(\w+)\.(\w+)\??(.*)/HREF=\"$cgiurl\/$2\.$3\?$4/;
    print FILE "$line";
}


#################################################
#    Copying default locconf and config         #
#################################################

# UPDATE : mv ressources/admin/locconf en locconf.default
# idem pour ressources/admin/config-xxx en config-xxx.default
# idem pour les config dans /config/

$w3perlpathres = $pathw3perl.$dirsep."resources".$dirsep."admin"; # w3perl resources path

if (!(-f "$w3perlpathres$dirsep$locconf")) {

    # locconf.default --> locconf

    if (-f "$w3perlpathres$dirsep$locconf_default") {
	open(FILE,"$w3perlpathres$dirsep$locconf_default");
	@lines = (<FILE>);
	close FILE;
    }

    open(FILE_LOC,">$w3perlpathres$dirsep$locconf") || die "Can't open $w3perlpathres$dirsep$locconf";
    foreach $line (@lines) {
	$line =~ s/(.*)$dirsep(.*)/$pathw3perl$dirsep$dirconfig$dirsep$2/;
	($file_conf) = split(/\s+/,$2);
	$file2_conf = $file_conf;
	$file2_conf = $pathw3perl.$dirsep.$dirconfig.$dirsep.$file2_conf;
	$file2_conf_cgi = $pathcgi.$dirsep.$file_conf;
	$file_conf =~ s/(.*)\.pl/$1/;
	$file_conf = $w3perlpathres.$dirsep.$file_conf;
	$file_conf_txt = $file_conf.".default";
#	&move_file($file_conf_txt,$file_conf,$delete_files) if (-f $file_conf_txt);
	&move_file($file_conf_txt,$file_conf,'1') if (-f $file_conf_txt);
        # deplace les fichiers de config dans cgi si non present
	&move_file($file2_conf,$file2_conf_cgi,'0') if (!(-f $file2_conf_cgi));
	# chmod 666 sur $file_conf et $file2_conf
	$cnt = chmod 0666, $file_conf;
	$cnt = chmod 0666, $file2_conf;
#	$line =~ s/$build_rpm_tmp// if ($opt_r ne '');
	$line =~ s/$opt_r// if ($opt_r ne '');
	print FILE_LOC "$line";
    }
    close(FILE_LOC);
    unlink("$w3perlpathres$dirsep$locconf_default");
    $cnt = chmod 0666, "$w3perlpathres$dirsep$locconf";

}


###############################################################
# Perform the substitutions for cron-* scripts                #
# It should leave it unchanged if the path is already correct #
###############################################################

print "<BR><LI><B>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print  "> Updating scripts ... \n" if $verbose;
print "</B><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

# Si depuis une interface web, alors les scripts sont en fait dans /cgi-bin/
$path3 = $path2 if ($ENV{'REQUEST_METHOD'} eq "GET");

$path2 =~ s/$opt_r//;

opendir(SOURCEDIR,$path3) || die "Couldn't open directory $path3 !!\n";
local(@filenames) = readdir(SOURCEDIR);
closedir(SOURCEDIR);

for ($j=0;$j<=$#filenames;$j++) {
    $file_update = $path3.$dirsep.$filenames[$j];

    next if ($file_update =~ m/$lib/);
    next if ($file_update =~ m/$cronw3perl/);
    next if ($file_update !~ m/cron/);

    &error_open($file_update) if (!(-r $file_update));
    open(FILE,"$file_update") || die "Can't open $file_update\n";
    @lines = (<FILE>);
    close FILE;

    unlink($file_update) if ($delete_files == 1);
    $file_update = $pathcgi.$dirsep.$filenames[$j];
    &error_write($file_update) if (!(-w $pathcgi));
    open(FILE2,">$file_update") || die "Can't open $file_update";

    foreach $i (0 .. $#lines) {
	$lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;
	$lines[$i] =~ s/^require \"?([^ ]*)libw3perl(.*)\";/require \"$path2$lib\";/;
	print FILE2 "$lines[$i]";
    }
    close (FILE2);


    &set_perm($file_update,$mode);
    print "$filenames[$j] updated\n";

#    print "$file_update updated\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#
### Perform the substitutions for fixperlpath script
#

$file_update = $path3.$fixperlpath;

&error_open($file_update) if (!(-r $file_update));
open(FILE,"$file_update") || die "Can't open $file_update\n";
@lines = (<FILE>);
close FILE;

unlink($file_update) if ($delete_files == 1);

if ($opt_r ne '') {
$tmp1 = $pathcgi;
$tmp1 =~ s/$opt_r//;
$tmp2 = $pathw3perl;
$tmp2 =~ s/$opt_r//;
}

$file_update = $pathcgi.$dirsep.$fixperlpath;
&error_write($file_update) if (!(-w $pathcgi));
open(FILE2,">$file_update") || die "Can't open $file_update\n";
   foreach $i (0 .. $#lines){
      $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;
#      $lines[$i] =~ s/\$pathcgi = "(.*)";/\$pathcgi = "$pathcgi";/;   
#      $lines[$i] =~ s/\$pathw3perl = "(.*)";/\$pathw3perl = "$pathw3perl";/;   

        # pathcgi

	if ($lines[$i] =~ /\$pathcgi = "(.*)";/) {
	    $already2 = 1;
	    $past2 = "$1";
	}
 
        $ok2 = 1 if ($lines[$i] =~ /Your CGI path/ && $already2 != 1);
        $ok2 = 2 if ($lines[$i] =~ /Your CGI path/ && ($already2 == 1 && $past2 ne $pathcgi));

        print FILE2 "\$pathcgi = \"$pathcgi\"; " if ($ok2 == 1 && $opt_r eq '');
        print FILE2 "\$pathcgi = \"$tmp1\"; " if ($ok2 == 1 && $opt_r ne '');
	if ($ok2 == 2) {
	    $lines[$i] =~ s/\"$past2\"/\"$pathcgi\"/ if ($opt_r eq '');
	    $lines[$i] =~ s/\"$past2\"/\"$tmp1\"/ if ($opt_r ne '');
	}

        $ok2 = 0 if ($ok2 == 1 || $ok2 == 2);

        # pathw3perl

	if ($lines[$i] =~ /\$pathw3perl = "(.*)";/) {
	    $already = 1;
	    $past = "$1";
	}
	
        $ok = 1 if ($lines[$i] =~ /Your W3Perl path/ && $already != 1);
        $ok = 2 if ($lines[$i] =~ /Your W3Perl path/ && ($already == 1 && $past ne $initw3perl));

	  print FILE2 "\$pathw3perl = \"$pathw3perl\"; " if ($ok == 1 && $opt_r eq '');
	  print FILE2 "\$pathw3perl = \"$tmp2\"; " if ($ok == 1 && $opt_r ne '');
	  if ($ok == 2) {
	      $lines[$i] =~ s/\"$past\"/\"$pathw3perl\"/ if ($opt_r eq '');
	      $lines[$i] =~ s/\"$past\"/\"$tmp2\"/ if ($opt_r ne '');
	  }

        $ok = 0 if ($ok == 1 || $ok == 2);


      print FILE2 "$lines[$i]";
   }
close (FILE2);

&set_perm($file_update,$mode);
print  "$fixperlpath updated\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#
### Perform the substitutions for netgeo script
#

$file_update = $path3.$netgeo;

&error_open($file_update) if (!(-r $file_update));
open(FILE,"$file_update") || die "Can't open $file_update\n";
@lines = (<FILE>);
close FILE;

unlink($file_update) if ($delete_files == 1);

$file_update = $pathcgi.$dirsep.$netgeo;

&error_write($file_update) if (!(-w $pathcgi));
open(FILE2,">$file_update") || die "Can't open $file_update\n";
   foreach $i (0 .. $#lines){
      $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;   
#      $lines[$i] =~ s/\$conf_file = \"?([^ ]*)config(.*)\";/\$conf_file = \"$path2$conf\";/ if ($lines[$i] =~ /\# install/i);
#      $lines[$i] =~ s/\$w3perlcgiurl = \"\"/\$w3perlcgiurl = \"$cgiurl\"/;
      print FILE2 "$lines[$i]";
   }
close (FILE2);

&set_perm($file_update,$mode);
print  "$netgeo updated\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#
### Perform the substitutions for geoip_free script
#

$file_update = $path3.$geoip_free;

&error_open($file_update) if (!(-r $file_update));
open(FILE,"$file_update") || die "Can't open $file_update\n";
@lines = (<FILE>);
close FILE;

unlink($file_update) if ($delete_files == 1);

$file_update = $pathcgi.$dirsep.$geoip_free;

&error_write($file_update) if (!(-w $pathcgi));
open(FILE2,">$file_update") || die "Can't open $file_update\n";
   foreach $i (0 .. $#lines){
      $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;   
#      $lines[$i] =~ s/\$conf_file = \"?([^ ]*)config(.*)\";/\$conf_file = \"$path2$conf\";/ if ($lines[$i] =~ /\# install/i);
#      $lines[$i] =~ s/\$w3perlcgiurl = \"\"/\$w3perlcgiurl = \"$cgiurl\"/;
      print FILE2 "$lines[$i]";
   }
close (FILE2);

&set_perm($file_update,$mode);
print  "$geoip_free updated\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");


#
### Perform the substitutions for libw3perl script
#

$file_update = $path3.$lib;

&error_open($file_update) if (!(-r $file_update));
open(FILE,"$file_update") || die "Can't open $file_update\n";
@lines = (<FILE>);
close FILE;

unlink($file_update) if ($delete_files == 1);

$file_update = $pathcgi.$dirsep.$lib;
&error_write($file_update) if (!(-w $pathcgi));
open(FILE2,">$file_update") || die "Can't open $file_update\n";
   foreach $i (0 .. $#lines){
      $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;   
#      $lines[$i] =~ s/require \"?([^ ]*)config(.*)\";/require \"$path2$conf\";/ if ($lines[$i] =~ /\# install/i);
      $lines[$i] =~ s/\$conf_file = \"?([^ ]*)config(.*)\";/\$conf_file = \"$path2$conf\";/ if ($lines[$i] =~ /\# install/i);
      $lines[$i] =~ s/\$w3perlcgiurl = \"\"/\$w3perlcgiurl = \"$cgiurl\"/;
      $lines[$i] =~ s/require \"?([^ ]*)netgeo(.*)\"/require \"$path2$netgeo\"/ if ($lines[$i] =~ /\$netgeo/i);
      $lines[$i] =~ s/require \"?([^ ]*)geoipfree(.*)\"/require \"$path2$geoip_free\"/ if ($lines[$i] =~ /\$geoip_free/i);
      print FILE2 "$lines[$i]";
   }
close (FILE2);

&set_perm($file_update,$mode);
print  "$lib updated\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#
### Perform the substitutions for cron-w3perl script
#

$file_update = $path3.$cronw3perl;

&error_open($file_update) if (!(-r $file_update));
open(FILE,"$file_update") || die "Can't open $file_update\n";
@lines = (<FILE>);
close FILE;

unlink($file_update) if ($delete_files == 1);

$ok = 0;
$past = '';
$already = 0;

$file_update = $pathcgi.$dirsep.$cronw3perl;
&error_write($file_update) if (!(-w $pathcgi));
open(FILE2,">$file_update") || die "Can't open $file_update\n";
foreach $i (0 .. $#lines) {

    $lines[$i] =~ s/^require \"?([^ ]*)libw3perl(.*)\";/require \"$path2$oldlib\";/;
    $lines[$i] =~ s/^#\! ?([^ ]*)perl(.*)/#\!$perlpath\/perl$2/;
    
    if ($lines[$i] =~ /\$w3perlpath = "(.*)";/) {
	$already = 1;
	$past = "$1";
    }
    
    $ok = 1 if ($lines[$i] =~ /Do not remove this line/ && $already != 1);
    $ok = 2 if ($lines[$i] =~ /Do not remove this line/ && ($already == 1 && $past ne $pathcgi));
    
    print FILE2 "\$w3perlpath = \"$pathcgi\"; " if ($ok == 1 && $opt_r eq '');
    print FILE2 "\$w3perlpath = \"$tmp1\"; " if ($ok == 1 && $opt_r ne '');
    if ($ok == 2) {
	$lines[$i] =~ s/\"$past\"/\"$pathcgi\"/ if ($opt_r eq '');
	$lines[$i] =~ s/\"$past\"/\"$tmp1\"/ if ($opt_r ne '');
    }
    $ok = 0 if ($ok == 1 || $ok == 2);
    print FILE2 "$lines[$i]";
}
close (FILE2);

&set_perm($file_update,$mode);
print  "$cronw3perl updated\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

#
### Copy configuration files for RPM
#

if ($opt_r ne '') {

    open(FILE_LOC,"$path3$dirresources$dirsep$diradmin$dirsep$locconf");
    while (<FILE_LOC>) {
	($file_conf) = split;
	$pos = rindex($file_conf,$dirsep)+1;
	$tmp = substr($file_conf,$pos,length($file_conf));
	$file_conf_cgi = $pathcgi.$dirsep.$tmp;
	$file_conf = $opt_r.$file_conf;
	&move_file($file_conf,$file_conf_cgi,$delete_files) if (-f $file_conf);
	# chmod 666 sur $file_conf et $file2_conf
	$cnt = chmod 0666, $file_conf_cgi;
	print  "$tmp copied\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    }
    close(FILE_LOC);

}


#
### Copy fly.exe on NT
#

#$pathflyrpm = "/usr/local/bin/";
if ($nt == 1) {

$file_update = $path3.$fly;

#($size) = (stat("$file_update"))[7];
$size = -s $file_update;
if ($size < 0) {
    print "Problem with fly binary size\n";
    exit;
}

&error_open($file_update) if (!(-r $file_update));
open(FILE,"$file_update") || die "Can't open $file_update\n";
binmode(FILE);
sysread(FILE,$tmp,$size);
close FILE;

unlink($file_update) if ($delete_files == 1);

$file_update = $pathcgi_server.$dirsep.$fly;
&error_write($file_update) if (!(-w $pathcgi));
open(FILE2,">$file_update") || die "Can't open $file_update\n";
binmode(FILE2);
syswrite(FILE2,$tmp,$size);   
close (FILE2);

#&set_perm($file_update,$mode);
print  "$fly copied\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

###############################################################
# Perform the substitutions for the cgi-bin scripts           #
# Scripts located in the same level as cron-* scripts         #
###############################################################

$path2b = $path3."cgi-bin".$dirsep."w3perl";
$tmp = "";
$tmp = $path2b.$dirsep if ($dirsep eq ".");

# confstat script

$file_update = $path3.$confstat;

if (-f $file_update) {
    &error_open($file_update) if (!(-r $file_update));
    open(FILE,"$file_update");
    @lines = (<FILE>);
    close FILE;

    unlink($file_update) if ($delete_files == 1);

    $file_update = $pathcgi.$dirsep.$confstat;
    &error_write($file_update) if (!(-w $pathcgi));
    open(FILE2,">$file_update");
    foreach $i (0 .. $#lines){
	$lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;
	$lines[$i] =~ s/^require \"?([^ ]*)init(.*)\";/require \"$path2$init\";/;
	print FILE2 "$lines[$i]";
    }
    close (FILE2);

    &set_perm($file_update,$mode);
    print  "$confstat updated\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#
### delconf script
#

$file_update = $path3.$delconf;

if (-f $file_update) {
    &error_open($file_update) if (!(-r $file_update));
    open(FILE,"$file_update");
    @lines = (<FILE>);
    close FILE;

    unlink($file_update) if ($delete_files == 1);

    $file_update = $pathcgi.$dirsep.$delconf;
    &error_write($file_update) if (!(-w $pathcgi));
    open(FILE2,">$file_update");
    foreach $i (0 .. $#lines){
	$lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;
	$lines[$i] =~ s/^require \"?([^ ]*)init(.*)\";/require \"$path2$init\";/;
	print FILE2 "$lines[$i]";
    }
    close (FILE2);

    &set_perm($file_update,$mode);    
    print  "$delconf updated\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#
### schedule script
#

$file_update = $path3.$schedule;

if (-f $file_update) {
    &error_open($file_update) if (!(-r $file_update));
    open(FILE,"$file_update");
    @lines = (<FILE>);
    close FILE;

    unlink($file_update) if ($delete_files == 1);

    $file_update = $pathcgi.$dirsep.$schedule;
    &error_write($file_update) if (!(-w $pathcgi));
    open(FILE2,">$file_update");
    foreach $i (0 .. $#lines){
        $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;
        $lines[$i] =~ s/^require \"?([^ ]*)init(.*)\";/require \"$tmp$init\";/;
        print FILE2 "$lines[$i]";      
    }
    close (FILE2);

    &set_perm($file_update,$mode);
    print  "$schedule updated\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}


#
### runconf script
#

$file_update = $path3.$runconf;

if (-f $file_update) {
    &error_open($file_update) if (!(-r $file_update));
    open(FILE,"$file_update");
    @lines = (<FILE>);
    close FILE;

    unlink($file_update) if ($delete_files == 1);

    $file_update = $pathcgi.$dirsep.$runconf;
    &error_write($file_update) if (!(-w $pathcgi));
    open(FILE2,">$file_update");
    foreach $i (0 .. $#lines){
        $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;
        $lines[$i] =~ s/^require \"?([^ ]*)init(.*)\";/require \"$tmp$init\";/;
        print FILE2 "$lines[$i]";      
    }
    close (FILE2);

    &set_perm($file_update,$mode);
    print  "$runconf updated\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#
### init script
#

$file_update = $path3.$init;

if (-f $file_update) {
    &error_open($file_update) if (!(-r $file_update));
    open(FILE,"$file_update");
    @lines = (<FILE>);
    close FILE;

    unlink($file_update) if ($delete_files == 1);

    $ok = 0;
    $past = '';
    $already = 0;

    $file_update = $pathcgi.$dirsep.$init;
    &error_write($file_update) if (!(-w $pathcgi));    
    open(FILE2,">$file_update");
    foreach $i (0 .. $#lines){
#        $lines[$i] =~ s/^require \"?([^ ]*)init(.*)\";/require \"$path2$init\";/;
        $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;

        # pathcgi

	if ($lines[$i] =~ /\$cgipath = "(.*)";/) {
	    $already2 = 1;
	    $past2 = "$1";
	}

        $ok2 = 1 if ($lines[$i] =~ /Do not remove this line/ && $already2 != 1);
        $ok2 = 2 if ($lines[$i] =~ /Do not remove this line/ && ($already2 == 1 && $past2 ne $pathcgi));

        print FILE2 "\$cgipath = \"$pathcgi\"; " if ($ok2 == 1);

	if ($ok2 == 2) {
	    $lines[$i] =~ s/\"$past2\"/\"$pathcgi\"/;
	}

        $ok2 = 0 if ($ok2 == 1 || $ok2 == 2);

	# w3perlpath

	if ($lines[$i] =~ /\$w3perlpath = "(.*)";/) {
	    $already = 1;
	    $past = "$1";
	}
	
        $ok = 1 if ($lines[$i] =~ /Do not change too/ && $already != 1);
        $ok = 2 if ($lines[$i] =~ /Do not change too/ && ($already == 1 && $past ne $initw3perl));
	
        print FILE2 "\$w3perlpath = \"$initw3perl\"; " if ($ok == 1);

	if ($ok == 2) {
	    $lines[$i] =~ s/\"$past\"/\"$initw3perl\"/;
	}
        $ok = 0 if ($ok == 1 || $ok == 2);

        print FILE2 "$lines[$i]";
    }
    close (FILE2);

    &set_perm($file_update,$mode);
    print  "$init updated\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

#
### pagegraph script
#

$file_update = $path3.$pagegraph;

if (-f $file_update) {
    &error_open($file_update) if (!(-r $file_update));
    open(FILE,"$file_update");
    @lines = (<FILE>);
    close FILE;

    unlink($file_update) if ($delete_files == 1);

    $ok = 0;
    $past = '';
    $already = 0;

    $file_update = $pathcgi.$dirsep.$pagegraph;
    &error_write($file_update) if (!(-w $pathcgi));    
    open(FILE2,">$file_update");
    foreach $i (0 .. $#lines){

	    $lines[$i] =~ s/^require \"?([^ ]*)libw3perl(.*)\";/require \"$path2$oldlib\";/;
        $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;

        print FILE2 "$lines[$i]";
    }
    close (FILE2);

    &set_perm($file_update,$mode);
    print  "$pagegraph updated\n";
    print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
}

###############################################################
# Scripts located in /w3perl/cgi-bin/w3perl/                  #
###############################################################

$path2b = $path3."cgi-bin".$dirsep."w3perl";
$tmp = "";
$tmp = $path2b.$dirsep if ($dirsep eq ".");

if (-d $path2b && ($ENV{'REQUEST_METHOD'} ne "GET")) {
    opendir(SOURCEDIR,$path2b) || die "Couldn't open directory $path2b !!\n";
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    for ($j=0;$j<=$#filenames;$j++) {

	$file_update = $path2b.$dirsep.$filenames[$j];

	next if ($filenames[$j] eq ".");
	next if ($filenames[$j] eq "..");

	&error_open($file_update) if (!(-r $file_update));
        open(FILE,"$file_update");
        @lines = (<FILE>);
        close FILE;

	unlink($file_update) if ($delete_files == 1);

        $ok = 0;
	$past = '';
	$already = 0;

	$file_update = $pathcgi.$dirsep.$filenames[$j];
	&error_write($file_update) if (!(-w $pathcgi));
	open(FILE2,">$file_update") || die "Can't open $file_update";	
        foreach $i (0 .. $#lines) {
	    
	    $lines[$i] =~ s/^require \"?([^ ]*)libw3perl(.*)\";/require \"$path2$oldlib\";/;
	    $lines[$i] =~ s/^require \"?([^ ]*)init(.*)\";/require \"$path2$init\";/;
	    $lines[$i] =~ s/^\#\! ?([^ ]*)perl(.*)/\#\!$perlpath\/perl$2/;

        # pathcgi

	    if ($lines[$i] =~ /\$cgipath = "(.*)";/) {
		$already2 = 1;
		$past2 = "$1";
	    }

	    $ok2 = 1 if ($file_update =~ /$init/ && $lines[$i] =~ /Do not remove this line/ && $already2 != 1);
	    $ok2 = 2 if ($file_update =~ /$init/ && $lines[$i] =~ /Do not remove this line/ && ($already2 == 1 && $past2 ne $pathcgi));

	    print FILE2 "\$cgipath = \"$pathcgi\"; " if ($ok2 == 1 && $opt_r eq '');
	    print FILE2 "\$cgipath = \"$tmp1\"; " if ($ok2 == 1 && $opt_r ne '');

	    if ($ok2 == 2) {
		$lines[$i] =~ s/\"$past2\"/\"$pathcgi\"/ if ($opt_r eq '');
		$lines[$i] =~ s/\"$past2\"/\"$tmp1\"/ if ($opt_r ne '');
	    }

	    $ok2 = 0 if ($ok2 == 1 || $ok2 == 2);

	    # w3perlpath

	    if ($lines[$i] =~ /\$w3perlpath = "(.*)";/) {
		$already = 1;
		$past = "$1";
	    }
	    
	    $ok = 1 if ($file_update =~ /$init/ && $lines[$i] =~ /Do not change too/ && $already != 1);
	    $ok = 2 if ($file_update =~ /$init/ && $lines[$i] =~ /Do not change too/ && ($already == 1 && $past ne $initw3perl));

	    print FILE2 "\$w3perlpath = \"$initw3perl\"; " if ($ok == 1 && $opt_r eq '');
	    print FILE2 "\$w3perlpath = \"$tmp2\"; " if ($ok == 1 && $opt_r ne '');

	    if ($ok == 2) {
		$lines[$i] =~ s/\"$past\"/\"$initw3perl\"/ if ($opt_r eq '');
		$lines[$i] =~ s/\"$past\"/\"$tmp2\"/ if ($opt_r ne '');
	    }
	    $ok = 0 if ($ok == 1 || $ok == 2);
	    print FILE2 "$lines[$i]";
	}
	close (FILE2);

	&set_perm($file_update,$mode);
	print  "$filenames[$j] updated\n";
	print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    }
}

################################################################
# Checking permissions files for /config/ and /resources/admin #
################################################################

$mode = 0777;

print "> Setting directories permission\n";
print "<BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

$tmp = $pathw3perl.$dirsep.$dirconfig;
&set_perm($tmp,$mode);
$tmp = $pathw3perl.$dirsep.$dirresources.$dirsep.$diradmin;
&set_perm($tmp,$mode);

print "<BR><B><I>" if ($ENV{'REQUEST_METHOD'} eq "GET");
print "> Successfully completed\n";
print "</B></I><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");

##################
# Errors report  #
##################

sub dodir {
    local($dir,$nlink,$symlinkdir) = @_;
    local($dev,$ino,$mode,$subcount);
   ($dev,$ino,$mode,$nlink) = stat('.') unless $nlink;

    opendir(SOURCEDIR,$dir) || die "Couldn't open directory $dir !!\n";
    local(@filenames) = readdir(SOURCEDIR);
    closedir(SOURCEDIR);

    if ($nlink == 2) {
        for (@filenames) {
	    next if $_ eq '.';
	    next if $_ eq '..';
	    next if ($_ =~ /\~$/);
	    next if ($_ =~ /rpm\.pl/);
	    $name = "$dir/$_";
	    $name2 = $name;
	    $name2 =~ s/$dir_base//;
	    $output = "$dir_html/$name2";

#	    print "COPY1 $name to $output\n";
#	    print "MKDIR1 $output\n" if (-d $name);
	    &move_file($name,$output,$delete_files) if (-f $name);
	    $output .= $dirsep if (-d $name);
	    mkdir ($output,0777) if (-d $name);
	    $name2 = $name2."\n";

	    $name3 = "$dir_cgi/$_\n" if ($_ =~ /\.pl/);
	    $name3 = "$dir_html/$name2" if ($_ !~ /\.pl/);
	    $name3 = "$dir_html/$name2" if ($_ =~ /global\.pl/);
	    $name3 = "$dir_html/$name2" if ($_ =~ /clean_log\.pl/);
	    $name3 = "$dir_html/$name2" if (length($_) == 5);
	    print FILE "$name3\n";

	}
    }
    else {
	$subcount = $nlink-2;
	
	for (@filenames) {
	    next if $_ eq '.';
	    next if $_ eq '..';
	    next if ($_ =~ /\~$/);
	    next if ($_ =~ /rpm\.pl/);
	    $name = "$dir/$_";
	    $name2 = $name;
	    $name2 =~ s/$dir_base//;
	    $output = "$dir_html/$name2";
	    $name3 = "$dir_cgi/$_" if ($_ =~ /\.pl/ && $_ !~ /global/);
	    $name3 = "$dir_html/$name2" if ($_ !~ /\.pl/);
	    $name3 = "$dir_html/$name2" if ($_ =~ /global\.pl/);
	    $name3 = "$dir_html/$name2" if ($_ =~ /clean_log\.pl/);
	    $name3 = "$dir_html/$name2" if (length($_) == 5);
	    print FILE $name3,"\n";
#	    print "COPY2 $name to $output\n" if (-f $name);
#	    print "MKDIR2 $output\n" if (-d $name);
	    &move_file($name,$output,$delete_files) if (-f $name);
	    $output .= $dirsep if (-d $name);
	    mkdir ($output,0777) if (-d $name);
	    next if ($subcount == 0);
	    ($dev,$ino,$mode,$nlink) = lstat($_);
	    next unless -d _;
	    chdir $_ || die "Can't cd to $name";
	    &dodir($name,$nlink);
	    chdir '..';
	    --$subcount;
	}
    }
}

sub error_open {
    local($file) = @_;

    print "<P><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "Unable to open $file : $!\n";
    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print " ==> check read permission\n";
    print "</DIR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    exit;
}

sub error_write {
    local($file) = @_;

    print "<P><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "Unable to write $file : $!\n";
    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print " ==> check write permission\n";
    print "</DIR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    exit;
}

sub set_perm {
    local($file,$mode) = @_;

    $cnt = chmod $mode, $file;
    $msg = "Unable to change file permission in $file to set them executable : $!";
    &error($msg) if ($cnt != 1);
}


sub error {
    local($msg) = @_;

    print "<P><DIR><FONT COLOR=\"#AA2020\">" if ($ENV{'REQUEST_METHOD'} eq "GET");
    print "$msg : $!\n";
    print "</FONT><BR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
#    print " ==> check write permission\n";
    print "</DIR>" if ($ENV{'REQUEST_METHOD'} eq "GET");
    exit;
}

sub id {
    local($affirmation) = @_;

print STDOUT "Yes\n" if ($affirmation == 1);
print STDOUT "No\n" if ($affirmation == 0);
}

sub move_file {
    local($infile,$outfile,$delete_files) = @_;
    local($tmp);

    $size = -s $infile;

    if ($size < 0) {
	print "Problem with corrupted file size : $infile\n";
	exit;
    }

#&error_open($file_update) if (!(-r $file_update));
    open(FILE,"$infile") || die "Can't open $infile\n";
    binmode(FILE);
    sysread(FILE,$tmp,$size);
    close FILE;

    unlink($infile) if ($delete_files == 1);

#$file_update = $pathcgi_server.$dirsep.$fly;
#&error_write($file_update) if (!(-w $pathcgi));
    open(FILE2,">$outfile") || die "Can't open $outfile\n";
    binmode(FILE2);
    syswrite(FILE2,$tmp,$size);
    close (FILE2);

}

1;
