#!/bin/sh
############################################################################
###
##
##
##  Copyright (C) 2001  Joe Mitchell (mitchelj@dma.org)
##
##
##
##  This program is free software; you can redistribute it and/or modify it
##
##  under the terms of the GNU General Public License as published by the
##
##  Free Software Foundation; either version 2 of the License, or (at your
##
##  option) any later version.
##
##
##
##  This program is distributed in the hope that it will be useful, but
##
##  WITHOUT ANY WARRANTY; without even the implied warranty of
##
##  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
##
##  GNU General Public License for more details.
##
##
##
##  You should have received a copy of the GNU General Public License along
##
##  with this program; if not, write to the Free Software Foundation, Inc.,
##
##  59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.
##
##
##
############################################################################
###

# This script will split a webserver log file from all-in-one format (access_log)
# into seperate daily logs (ex. access_010613.log)

for year in 1999 2000 2001; do
  for month in Jan Feb Mar Apr May Jun Jul Aug Sep Oct Nov Dec; do
    case $month in
        Jan) monnum=01
                ;;
        Feb) monnum=02
                ;;
        Mar) monnum=03
                ;;
        Apr) monnum=04
                ;;
        May) monnum=05
                ;;
        Jun) monnum=06
                ;;
        Jul) monnum=07
                ;;
        Aug) monnum=08
                ;;
        Sep) monnum=09
                ;;
        Oct) monnum=10
                ;;
        Nov) monnum=11
                ;;
        Dec) monnum=12
                ;;
        esac
    for day in 01 02 03 04 05 06 07 08 09 10 11 12 13 14 15 16 17 18 19 20 21 22 23 24 25 26 27 28 29 30 31; do
      grep $day/$month/$year access_log >> access_$year$monnum$day.log
      if [ -s access_$year$monnum$day.log ]; then
        echo "access_$year$monnum$day.log"
      else
        rm access_$year$monnum$day.log
      fi
    done
  done
done


